import sympy
from sympy.polys.subresultants_qq_zz import *

from sympy import symbols, pprint, Poly

x, y = symbols('x y')

f = x**6 - 7*x**4 + 5*x**2 + 3
g = x**5 + 3*x**3 - 2*x + 7

print('f = ', f, '\n')
print('g = ', g, '\n')

pprint(sylvester(f, g, x, 1))
print('\n')
pprint(sylvester(f, g, x, 2))
print('\n')
print('bezout(f, g, x, "bz")', '\n')
pprint(bezout(f, g, x, 'bz'))
print('\n')
print('bezout(f, g, x, "prs")', '\n')
pprint(bezout(f, g, x, 'prs'))
print('\n')

print('backward_eye(6) * bezout(f, g, x, "bz") * backward_eye(6) ==')
print('      bezout(f, g, x, "prs")')
print('\n')
print(backward_eye(6) * bezout(f, g, x, 'bz') * backward_eye(6) ==
      bezout(f, g, x, 'prs'))

print('\n')
print('sylvester(f, g, x, 1).det() = ', sylvester(f, g, x, 1).det(), '\n')
print('sylvester(f, g, x, 2).det() = ', sylvester(f, g, x, 2).det(), '\n')

print('bezout(f, g, x, "bz").det() = ', bezout(f, g, x, 'bz').det(), '\n')
print('bezout(f, g, x, "prs").det() = ', bezout(f, g, x, 'prs').det(), '\n')

print('euclid_q = ', euclid_q(f, g, x),'\n')
print('euclid_amv = ', euclid_amv(f, g, x),'\n')
print('subrs_sylv1 = ', subresultants_sylv(f, g, x), '\n')
print('subrs_bez(prs) = ', subresultants_bezout(f, g, x), '\n')

print('sturm_q = ', sturm_q(f, g, x), '\n')
print('sturm_amv = ', sturm_amv(f, g, x), '\n')
print('mod_subrs_sylv2 = ', modified_subresultants_sylv(f, g, x), '\n')
print('mod_subrs_bez(prs) = ', modified_subresultants_bezout(f, g, x), '\n')


print('\n')
f = x**5 + 5*x**2 - 7*x + 7
g = x**3 - 6*x + 8
print('f = ', f, '\n')
print('g = ', g, '\n')


print('euclid_q = ', euclid_q(f, g, x),'\n')
print('euclid_amv = ', euclid_amv(f, g, x),'\n')
print('subrs_sylv1 = ', subresultants_sylv(f, g, x), '\n')
print('subrs_bez(prs) = ', subresultants_bezout(f, g, x), '\n')

print('sturm_q = ', sturm_q(f, g, x), '\n')
print('sturm_amv = ', sturm_amv(f, g, x), '\n')
print('mod_subrs_sylv2 = ', modified_subresultants_sylv(f, g, x), '\n')
print('mod_subrs_bez(prs) = ', modified_subresultants_bezout(f, g, x), '\n')

