from sympy import IndexedBase, Matrix, Mul, Poly, var, pprint
from sympy import rem, prod, fraction, total_degree, degree_list
from sympy.core.compatibility import range
from sympy.polys.monomials import monomial_deg
from sympy.polys.monomials import itermonomials
from sympy.polys.orderings import monomial_key
from sympy.polys.polytools import poly_from_expr
from sympy.functions.combinatorial.factorials import binomial

from itertools import combinations_with_replacement

from sympy import symbols, solve, factor, expand, simplify

from sympy.polys.subresultants_qq_zz import *

from operator import itemgetter  # to find max/min in a list of tuples

x, y, z = symbols('x y z')

monomials = list(itermonomials([x, y, z], 4))
print('monomials = ', monomials)
print('\n')
print(len(monomials))
print('\n')
print('total degrees = ', [total_degree(mono, *[x, y, z]) for mono in monomials])
print('\n')


polys = [Poly(monomial, x, y, z).monoms() for monomial in monomials]
print('polys = ', polys)

print('\n')
list=[]
[list.append(lst[0]) for lst in polys if monomial_deg(lst[0])==4]
#for lst in polys:
 #   if monomial_deg(lst[0])==4:
  #      list.append(lst[0])
print('list = ', list)
print('\n')
print(len(list))
print('\n')

def as_expr(tuple, *gens):
#    Convert a monomial instance to a SymPy expression. 

    if not gens:
        raise ValueError(
            "can't convert %s to an expression without generators" % self)

    return Mul(*[ gen**exp for gen, exp in zip(gens, tuple) ])


monomials2 = []
[monomials2.append(as_expr(monomial, x, y, z)) for monomial in list]
print('monomials2 = ', monomials2)


def takeFirst(elem):
    return elem[0]

def takeSecond(elem):
    return elem[1]

def takeThird(elem):
    return elem[2]

"""
print('monomials2 = ', monomials2)
print('\n')
monomial2 = sorted(monomials2, reverse=False,
                         key=monomial_key(takeFirst, [x, y, z]))
print('monomials2 = ', monomials2)
print('\n')

deg_ListsX = [degree_list(mono, *[x, y, z]) for mono in monomials2]
print('deg_ListsX = ', deg_ListsX)
print('\n')


monomial2 = sorted(deg_ListsX, reverse=False,
                         key=takeFirst)
print('monomials2 = ', monomials2)
print('\n')


"""
# random list
random = [(2, 2), (3, 4), (4, 1), (1, 3)]
print('random = ', random)

# sort list with key
sortedList = sorted(random, key=takeFirst, reverse=True)

# print list
print('Sorted list:', sortedList)
print('\n')

print( 'max degree of x =', max(sortedList,
                                key=itemgetter(0))[0] )
print( 'max degree of y =', max(sortedList,
                                key=takeSecond)[1] )

"""
# Example 15 (Stiler p. 10)
print('Example 15 (Stiler p. 10)')
print('\n')
x, y = symbols('x y')

f = y + 3*x + 5
g = x**2 + y**2 - 5
h = y - x**3 + 3*x**2 - 3*x + 1

print('f = ', f)
print('g = ', g)
print('h = ', h)
print('\n')

polynomials = [f, g, h]
variables = [x, y]


monomsF = Poly(f, x, y).monoms()
print('monomials of f = ', monomsF)
monomsG = Poly(g, x, y).monoms()
print('monomials of f = ', monomsG)
monomsH = Poly(h, x, y).monoms()
print('monomials of f = ', monomsH)
print('\n')
print('monomsFGH = ', monomsF + monomsG + monomsH)
monomsFGH = monomsF + monomsG + monomsH

all_monomials = []
for j in range(len(polynomials)):
    all_monomials.extend( Poly(polynomials[j], *variables).monoms())
print('all_monomials = ', all_monomials )

# To find the max in see https://stackoverflow.com/questions/13145368/
# find-the-maximum-value-in-a-list-of-tuples-in-python

from operator import itemgetter

print( 'max degree of x =', max(all_monomials,key=itemgetter(0))[0] )
print( 'max degree of y =', max(all_monomials,key=itemgetter(1))[1] )

max_degrees = [max(all_monomials,key=itemgetter(i))[i] for i in range(len(variables))]
print('max_degrees = ', max_degrees)
"""