# Extract coefficients and corresponding monomials
# from a given polynomial in SymPy


from sympy import *
x, y = symbols('x y')
p = Poly(x**3 + 2*x**2 + 3*x*y + 4*y**2 + 5*y**3, x, y)
q = Poly(x**3 + 2*x**2 + 3*x*y + 4*y**2 + 5*y**3, y, x)

print('p = ', p, '\n')
print('q = ', q, '\n')
print('p.gens = ', p.gens, '\n')    #  (x, y)
print('q.gens = ', q.gens, '\n')    #  (y, x)
print('q as expression = ', q.as_expr(), '\n') 

print('\n \n')
print('p as expression = ', p.as_expr(), '\n') 
print('p.monomials = ', p.monoms(), '\n')
print('zip(p.gens, mon) = ', [list(zip(p.gens, mon)) for mon in p.monoms()], '\n')

print('monomials of p = ', [prod(x**k for x, k in zip(p.gens, mon))
       for mon in p.monoms()], '\n')

print('coefficients of p = ', p.coeffs(), '\n')


print('\n \n')
print('q as expression = ', q.as_expr(), '\n') 
print('q.monomials = ', q.monoms(), '\n')
print('zip(p.gens, mon) = ', [list(zip(q.gens, mon)) for mon in q.monoms()], '\n')
print('coefficients of q = ', q.coeffs(), '\n')
print('monomials of q = ', [prod(x**k for x, k in zip(q.gens, mon))
       for mon in q.monoms()], '\n')
